unit ControlPanel;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons;

type
  TControl_Panel = class(TForm)
    StaticText1: TStaticText;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    StaticText9: TStaticText;
    StaticText10: TStaticText;
    procedure ClearImage(Sender: TObject);
    procedure Finish(Sender: TObject);
    procedure Interpolation(Sender: TObject);
    procedure SetDraw2D(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Control_Panel: TControl_Panel;

implementation

uses Graph2d_256_Interpol;

{$R *.DFM}

procedure TControl_Panel.ClearImage(Sender: TObject);
begin
  With Draw2D do
  begin
    ClearImage(slWhite);
    XScale(x1,x2,0,clRed);YScale(y1,y2,0,clRed);
  end;
  index:=0;
end;

procedure TControl_Panel.Finish(Sender: TObject);
begin
  Draw2D.Visible:=False;halt;
end;

procedure TControl_Panel.Interpolation(Sender: TObject);
var L             :TArrayOfPoints;
    i,n           :Integer;
    x,y           :array [0..20] of real;
    hx            :Real;
    Red,Green,Blue:Byte;
    HustotaKrivky :Integer;

    Function Mocnina(zaklad:Real;Exponent:Integer):Real;
    var Moc    :Extended;
        i,Exp  :Integer;
    begin
      Exp:=Abs(Exponent);Moc:=Zaklad;
      if Exp<>0 then for i:=1 to Exp do Moc:=Moc*Zaklad;
      if Exponent<0 then Moc:=1/Moc;
      Mocnina:=Moc;
    end;

    function Lagrange(z:Real):Real;
    var i,j                    :Integer;
        Lagr,Prirustek:Real;
    begin
      Lagr:=0;
      for i:=0 to n-1 do
      begin
         Prirustek:=1;
         for j:=0 to n-1 do
           if i<>j then
             Prirustek   :=Prirustek*(z-x[j])/(x[i]-x[j]);
         Lagr:=Lagr+y[i]*Prirustek;
      end;
      Lagrange:=Lagr;
    end;

begin
  n:=index;
  if n=0 then
          begin messagedlg('Set Points by Mouse!',mterror,[mbok],0);exit;end;

  With Draw2d do hx:=(x2-x1)/n;
  {***** sestrojeni polynomu *******}
  HustotaKrivky:=200;
  With Draw2D do
  begin Q[0,1]:=x1;hx:=(x2-x1)/HustotaKrivky;
  For i:=1 to HustotaKrivky-1 do Q[i,1]:=Q[i-1,1]+hx;
  for i:=0 to n-1 do begin x[i]:=P[i,1];y[i]:=P[i,2];end;
  for i:=0 to HustotaKrivky-1 do Q[i,2]:=Lagrange(Q[i,1]);
  PolyLine(Q,HustotaKrivky,slBlue);
  Image1.Repaint;
  end;
end;

procedure TControl_Panel.SetDraw2D(Sender: TObject);
begin
  Application.CreateForm(TDraw2D, Draw2D);
  With Draw2D do
  begin
    InitImage(500,500);ClearImage(slWhite);
    Caption:='Interpolation';
    Visible:=True;
   x1:=-5;x2:=5;y1:=-6;y2:=6;Scale(x1,x2,y1,y2);
   XScale(x1,x2,0,clRed);YScale(y1,y2,0,clRed);
   index:=0;
  end;

end;

end.
